(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      7543,        210]
NotebookOptionsPosition[      7065,        193]
NotebookOutlinePosition[      7462,        209]
CellTagsIndexPosition[      7419,        206]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"codetofunction", "[", 
   RowBox[{"f_", ",", " ", "c__", ",", " ", "t0_", ",", " ", "y0_"}], "]"}], 
  " ", ":=", " ", 
  RowBox[{"(", 
   RowBox[{"If", " ", "[", 
    RowBox[{
     RowBox[{"c", " ", "==", " ", 
      RowBox[{"{", "}"}]}], ",", " ", 
     RowBox[{"Return", " ", "[", "y0", "]"}], ",", "\n", 
     RowBox[{"Return", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", 
             RowBox[{"t", ",", " ", "y"}], "]"}], ",", " ", 
            RowBox[{"{", 
             RowBox[{"t", ",", " ", 
              RowBox[{"c", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", 
            RowBox[{"c", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}], " ", "/.", " ", 
        RowBox[{"{", 
         RowBox[{"t", " ", "->", " ", "t0"}], "}"}]}], " ", "/.", " ", 
       RowBox[{"{", 
        RowBox[{"y", " ", "->", " ", "y0"}], "}"}]}], "]"}]}], "]"}], 
   ")"}]}], "\n", 
 RowBox[{
  RowBox[{"MCsample", "[", 
   RowBox[{
   "f_", ",", " ", "t_", ",", " ", "t0_", ",", " ", "y0_", ",", " ", "c__", 
    ",", " ", "h_"}], "]"}], " ", ":=", " ", 
  RowBox[{"(", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", ",", " ", "tau"}], "}"}], ",", " ", 
     RowBox[{
      RowBox[{"tau", " ", "=", " ", 
       RowBox[{"RandomVariate", "[", 
        RowBox[{"ExponentialDistribution", "[", "1", "]"}], "]"}]}], ";", 
      "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"tau", " ", ">", " ", 
         RowBox[{"t", " ", "-", " ", "t0"}]}], ",", " ", 
        RowBox[{"Return", " ", "[", 
         RowBox[{"h", "*", 
          RowBox[{
           RowBox[{"codetofunction", "[", 
            RowBox[{"f", ",", " ", "c", ",", " ", "t0", ",", " ", "y0"}], 
            "]"}], "/", 
           RowBox[{"E", "^", 
            RowBox[{"(", 
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"t", " ", "-", " ", "t0"}], ")"}]}], ")"}]}]}]}], 
         "]"}], ",", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"c", " ", "==", " ", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"Return", "[", 
           RowBox[{"MCsample", "[", 
            RowBox[{"f", ",", " ", 
             RowBox[{"t", " ", "-", " ", "tau"}], ",", " ", "t0", ",", " ", 
             "y0", ",", " ", 
             RowBox[{"{", 
              RowBox[{"0", ",", " ", "0"}], "}"}], ",", " ", 
             RowBox[{"h", "/", 
              RowBox[{"E", "^", 
               RowBox[{"(", 
                RowBox[{"-", "tau"}], ")"}]}]}]}], "]"}], "]"}], ",", "\n", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"RandomVariate", "[", 
               RowBox[{"UniformDistribution", "[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], " ", "<=", " ", "0.5"}], ",", 
            "\n", 
            RowBox[{"Return", "[", 
             RowBox[{"MCsample", "[", 
              RowBox[{"f", ",", " ", 
               RowBox[{"t", " ", "-", " ", "tau"}], ",", " ", "t0", ",", " ", 
               "y0", ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"c", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", "1"}], ",", 
                 " ", 
                 RowBox[{"c", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", " ", 
               RowBox[{"2", "*", 
                RowBox[{"h", "/", 
                 RowBox[{"E", "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "tau"}], ")"}]}]}]}]}], "]"}], "]"}], ",", 
            "\n", 
            RowBox[{
             RowBox[{"A", " ", "=", " ", 
              RowBox[{"MCsample", "[", 
               RowBox[{"f", ",", " ", 
                RowBox[{"t", " ", "-", " ", "tau"}], ",", " ", "t0", ",", " ",
                 "y0", ",", " ", 
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", "0"}], "}"}], ",", " ", "1"}], 
               "]"}]}], ";", "\n", 
             RowBox[{"Return", "[", 
              RowBox[{"MCsample", "[", 
               RowBox[{"f", ",", " ", 
                RowBox[{"t", " ", "-", " ", "tau"}], ",", " ", "t0", ",", " ",
                 "y0", ",", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"c", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                  RowBox[{
                   RowBox[{"c", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], " ", "+", " ", "1"}]}], 
                 "}"}], ",", " ", 
                RowBox[{"2", "*", "A", "*", 
                 RowBox[{"h", "/", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"-", "tau"}], ")"}]}]}]}]}], "]"}], "]"}]}]}], 
           "]"}]}], "]"}]}], "]"}]}]}], "]"}], ")"}]}], "\n", 
 RowBox[{
  RowBox[{"Solution", "[", 
   RowBox[{
   "f_", ",", " ", "t_", ",", " ", "t0_", ",", " ", "y0_", ",", " ", "n_"}], 
   "]"}], " ", ":=", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"temp", " ", "=", " ", "0"}], ";", " ", 
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
      RowBox[{"i", " ", "<=", " ", "n"}], ",", " ", 
      RowBox[{"i", "++"}], ",", " ", 
      RowBox[{"temp", " ", "+=", " ", 
       RowBox[{"MCsample", "[", 
        RowBox[{
        "f", ",", " ", "t", ",", " ", "t0", ",", " ", "y0", ",", " ", 
         RowBox[{"{", "}"}], ",", "\n", "1"}], "]"}]}]}], "]"}], ";", " ", 
    RowBox[{"Return", "[", 
     RowBox[{"temp", "/", "n"}], "]"}]}], ")"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"t_", ",", " ", "y_"}], "]"}], " ", ":=", " ", 
   RowBox[{"y", "^", "2"}]}], ";", 
  RowBox[{"Solution", "[", 
   RowBox[{
   "f", ",", " ", "0.5", ",", " ", "0", ",", " ", "1", ",", " ", "100000"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.870377764190792*^9, 3.870377764191058*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"db317db4-9b09-40e7-88e4-dfb6b0df8b6b"],

Cell[BoxData["1.980983108985912`"], "Output",
 CellChangeTimes->{3.870377767717229*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"3a612fda-c22f-4448-8f16-3c6cdd36a36d"]
}, Open  ]]
},
WindowSize->{606., 524.25},
WindowMargins->{{241.5, Automatic}, {48, Automatic}},
FrontEndVersion->"13.1 for Linux x86 (64-bit) (June 16, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"a4f04bcf-f388-4ec9-9cf8-7eff7eed54f2"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 6300, 164, 511, "Input",ExpressionUUID->"db317db4-9b09-40e7-88e4-dfb6b0df8b6b"],
Cell[6883, 188, 166, 2, 56, "Output",ExpressionUUID->"3a612fda-c22f-4448-8f16-3c6cdd36a36d"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

